package kernel.analyzer;

/**
 * Description: Interface for proposed grammar.
 * 
 * @author david.kosek
 * @date 13. 11. 2014 18:22:38
 * @version $Rev$
 */
public interface ISyntactitAnalysis {

	/**
	 * Check input from user if it is correct
	 * 
	 * @param aInput input from user
	 * @return true if it was correct or false
	 */
	boolean checkInput(String aInput);

	/**
	 * Check if word is composed of alphabets
	 * 
	 * @param aWord request word
	 * @return true if it is word or false
	 */
	boolean checkValueIsWord(String aWord);

	/**
	 * Setting array to simple elements
	 * 
	 * @return array split to simple text
	 */
	String[] getSplitArrayIntoSimpleText();

	boolean checkValueIsNumber(String aNumber);

}
