package kernel.analyzer;

import java.util.ArrayList;
import java.util.List;

public class SemanticAnalysis implements ISemanticAnalysis {

	/**
	 * Declaration flag for input
	 */
	private boolean stdInFlag = false;

	/**
	 * Declaration variable for name of file
	 */
	private String stdInNameFile = null;

	/**
	 * Declaration flag for output
	 */
	private boolean stdOutFlag = false;

	/**
	 * Declaration variable for name of file
	 */
	private String stdOutNameFile = null;

	/**
	 * Declaration flag for append
	 */
	private boolean appendOutFlag = false;

	/**
	 * Declaration variable for name of command
	 */
	private String command = null;

	/**
	 * Declaration list of parametrs and arguments
	 */
	private List<String> parametsAndArgumentsList = new ArrayList<String>();

	/**
	 * Decalaration list of single commands
	 */
	private List<InputParseObject> resultInputList = new ArrayList<InputParseObject>();

	@Override
	public void setValuesAndCheckCommand(String[] aInput) {
		this.setValuesToDefault();

		command = aInput[0];

		for (int i = 1; i < aInput.length; i++) {

			if (SchemaMetaDataCommand.BASIC_SYMBOL.LEFT_ARROW.equals(aInput[i])) {
				stdInFlag = true;
				stdInNameFile = aInput[i + 1];
				i++;
			}
			else if (SchemaMetaDataCommand.BASIC_SYMBOL.RIGHT_ARROW.equals(aInput[i])) {
				stdOutFlag = true;
				stdOutNameFile = aInput[i + 1];
				i++;
			}
			else if (SchemaMetaDataCommand.BASIC_SYMBOL.DOUBLE_RIGHT_ARROW.equals(aInput[i])) {
				appendOutFlag = true;
				stdOutNameFile = aInput[i + 1];
				i++;
			}
			else if (SchemaMetaDataCommand.BASIC_SYMBOL.PIPE.equals(aInput[i])) {
				resultInputList.add(new InputParseObject(
						stdInFlag,
						stdInNameFile,
						stdOutFlag,
						stdOutNameFile,
						appendOutFlag,
						command,
						parametsAndArgumentsList));
				this.setValuesToDefault();
				i++;
				command = aInput[i];
			}
			else {
				parametsAndArgumentsList.add(aInput[i]);
			}

		}

		resultInputList.add(new InputParseObject(
				stdInFlag,
				stdInNameFile,
				stdOutFlag,
				stdOutNameFile,
				appendOutFlag,
				command,
				parametsAndArgumentsList));

	}

	/**
	 * Reset variables to default values
	 */
	private void setValuesToDefault() {
		this.stdInFlag = false;
		this.stdOutFlag = false;
		this.stdInNameFile = null;
		this.stdOutNameFile = null;
		this.appendOutFlag = false;
		this.parametsAndArgumentsList = new ArrayList<String>();
		this.command = null;
	}

	@Override
	public List<InputParseObject> getResultInputList() {
		return resultInputList;
	}
}
