package kernel.file;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PipedOutputStream;

import kernel.service.CustomException;

/**
 * Description: Read text from file over stream.
 * 
 * @author david.kosek
 * @date 2. 12. 2014 15:55:54
 * @version $Rev$
 */
public class InputFileForReadStream {

	/**
	 * Setting properties for read file over stream
	 * 
	 * @param nameFile name of file
	 * @param outputStream piped output stream
	 */
	public static void InputFileForReadStreamStatic(String nameFile, PipedOutputStream outputStream) {
		BufferedWriter bufferWriter = new BufferedWriter(new OutputStreamWriter(outputStream));

		InputUtility input = new InputUtility(nameFile);

		String line = null;

		while ((line = input.read()) != null) {
			System.out.println("ctu: " + line);
			try {
				line += "\n";
				bufferWriter.write(line);
				bufferWriter.flush();
			}
			catch (IOException e) {
				CustomException.printException(e, "Cannot read other line");

			}
		}
		try {
			bufferWriter.write(Character.ENCLOSING_MARK);
			bufferWriter.flush();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		input.close();

	}
}
