package kernel.file;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PipedInputStream;

import kernel.service.CustomException;

/**
 * Description: Write text to file over stream.
 * 
 * @author david.kosek
 * @date 2. 12. 2014 15:36:05
 * @version $Rev$
 */
public class OutputFileForWriteStream {

	/**
	 * Setting properties for write to file over stream
	 * 
	 * @param aNameFile name of file
	 * @param aAppend true if I want append text to end file
	 * @param aInputStream input piped stream
	 */
	public static void OutputFileForWriteStreamStatic(String aNameFile, Boolean aAppend, PipedInputStream aInputStream) {
		OutputUtility out;

		BufferedReader bufferReader = new BufferedReader(new InputStreamReader(aInputStream));

		out = new OutputUtility(aNameFile, aAppend);

		try {
			String line;
			while (bufferReader.ready()) {
				line = bufferReader.readLine();
				out.write(line + System.getProperty("line.separator"));
			}
		}
		catch (IOException e) {
			CustomException.printException(e, "Cannot write this to file.");
		}
		finally {
			out.close();
		}
	}
}
