package kernel.process;

import java.util.List;

import kernel.relation.Relation;
import kernel.service.Input;
import kernel.service.Output;

/**
 * Interface pro create process
 *
 */
public interface IProcess {
	/**
	 * Method for set input
	 * 
	 * @param input
	 */
	void setInput(Input input);
	/**
	 * Method for set output
	 * 
	 * @param output
	 */
	void setOutput(Output output);
	/**
	 * Method get instance of Input
	 * 
	 * @return Input
	 */
	Input getInput();
	/**
	 * Method get instance of Output
	 * 
	 * @return Output
	 */
	Output getOutput();
	/**
	 * Method set process ID
	 * 
	 * @param PID process ID
	 */
	void setPID(int PID);
	/**
	 * Method get parent ID
	 * 
	 * @return process ID
	 */
	int getPID();
	/**
	 * Method set process parent ID
	 * 
	 * @param PPID process parent ID
	 */
	void setPPID(int PPID);
	/**
	 * Method get process parent id
	 * 
	 * @return process parent ID
	 */
	int getPPID();
	/**
	 * Method set relation
	 * 
	 * @param relation
	 */
	void setRelation(Relation relation);
	/**
	 * Method get relation
	 * 
	 * @return instance of relation
	 */
	Relation getRelation();
	/**
	 * Method set parameters and arguments
	 * 
	 * @param ParametsAndArguments
	 */
	void setParametsAndArguments(List<String> ParametsAndArguments);
	/**
	 * Method get parameters and arguments
	 * 
	 * @return parameters and arguments
	 */
	List<String> getParametsAndArguments();
	/**
	 * Method for start process
	 */
	void start();
}
