package kernel.process;

import java.util.List;

import kernel.relation.Relation;
import kernel.service.Input;
import kernel.service.Output;

/**
 * Abstract class for create process
 *
 */
public abstract class Process extends Thread implements IProcess {
	/**
	 * Input
	 */
	private Input input;
	/**
	 * Output
	 */
	private Output output;
	
	/**
	 * Process ID
	 */
	private int PID;
	/**
	 * Parent process ID
	 */
	private int PPID;
	
	/**
	 * Relation
	 */
	private Relation relation;
	/**
	 * Parameters and arguments
	 */
	private List<String> parametsAndArguments;
	
	@Override
	public void setInput(Input input) {
		this.input = input;
	}
	@Override
	public void setOutput(Output output) {
		this.output = output;
	}
	@Override
	public Input getInput() {
		return input;
	}

	@Override
	public Output getOutput() {
		return output;
	}
	
	@Override
	public void setPID(int PID) {
		this.PID = PID;	
	}
	
	@Override
	public int getPID() {
		return PID;
	}
	
	@Override
	public void setPPID(int PID) {
		this.PPID = PID;
		
	}
	
	@Override
	public int getPPID() {
		return PPID;
	}
	
	@Override
	public Relation getRelation() {
		return relation;
	}
	
	@Override
	public void setRelation(Relation relation) {
		this.relation = relation;
	}
	
	@Override
	public void setParametsAndArguments(List<String> parametsAndArguments) {
		this.parametsAndArguments = parametsAndArguments;
	}

	@Override
	public List<String> getParametsAndArguments() {
		return parametsAndArguments;
	}
}
