package kernel.process;

import java.lang.reflect.Constructor;

/**
 * Class for create instance of class in package bin
 * 
 * @author 1Max11
 *
 */
public class ProgramInitializer {

	/**
	 * Method for get instance class in package bin
	 * 
	 * @param command Name command
	 * @return instance of class in package bin
	 */
	public static IProcess getProcess(String command) {
		try {
			Class<?> clazz = Class.forName("kernel.process.bin." + command.substring(0, 1).toUpperCase() + command.substring(1));

			Constructor<?> ctor = clazz.getConstructor();
			IProcess object = (IProcess) ctor.newInstance();
			return object;
		}
		catch (ClassNotFoundException e) {
			System.err.println("Program not found");
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}
