package kernel.process.bin;

import kernel.file.FileManager;
import kernel.process.Process;

/**
 * Class for reading from stream
 *
 */
public class Cat extends Process {
		
	private boolean numberLines = false;

	@Override
	public void run() {		
		int id = 0;
		while(true) {
			if (getParametsAndArguments().size() > id) {
				if (getParametsAndArguments().get(id).equals("-n")) {
					numberLines = true;
				} else if (getParametsAndArguments().get(id).charAt(0) != '-') {
					break;
				}
				id++;
			} else {
				break;
			}
		}
		
		int numberLine = 1;
		String text = "";
		if (id == getParametsAndArguments().size()) {
			String line;
			while ((line = getInput().readLine()) != null && line.charAt(line.length()-1) != Character.ENCLOSING_MARK) {
				if (numberLines) {						
					text += numberLine++ + "    " + line + "\n";
				} else {
					text += line + "\n";
				}
			}
		} else {
			for (int i = id; i < getParametsAndArguments().size(); i++) {
				String file = getParametsAndArguments().get(i);
				FileManager fm = new FileManager();
				fm.openFileForRead(file);
				String line = null;
				while((line = fm.readFromFile()) != null){
					if (numberLines) {						
						text += numberLine++ + "    ";
					} 
					text += line + "\n";
				}
				fm.closeReadToFile();
			}
		}

		getOutput().write(text);
	}
}
