package kernel.process.bin;

import java.io.File;

import kernel.file.FileManager;
import kernel.process.Process;

/**
 * The program delete file (files) or directory (directories)
 */
public class Del extends Process {

	@Override
	public void run() {
		String text = "";
		boolean recursively = false;
		String path = getRelation().getPath();
		FileManager fm = new FileManager();
		if (getParametsAndArguments().size() == 0) {
			text += "Nothing to delete.\n";
		}
		else {
			if (getParametsAndArguments().get(0).equalsIgnoreCase("-r")){
				recursively = true;
				getParametsAndArguments().remove(0);
			}
			for (String p : getParametsAndArguments()) {
				path = new File(p).isAbsolute() ? p : (path + p); //cestu vzdy prevedu na absolutni
				if(fm.deleteFile(path, recursively)){
					text += p + " was successful deleted.\n";
				}else {
					text += p + " wasn't deleted!\n";
				}
			}
		}

		getOutput().write(text);
	}
}
