package kernel.process.bin;

import kernel.process.Process;

/**
 * Class for reading from terminal
 * 
 *
 */
public class Echo extends Process {
	
	private boolean removeNewLine = false; //-n
	private boolean enebleBackslashEscapes = false; // -e or -E

	@Override
	public void run() {
		String text = "";
		boolean option = true;
		for (String string : getParametsAndArguments()) {
			if (option) {
				if (string.equals("-e")) {
					enebleBackslashEscapes = true;
				} else if (string.equals("-E")) {
					enebleBackslashEscapes = false;
				} else if (string.equals("-n")) {
					removeNewLine = true;
				} else {
					option = false;
					text += string;
				}
			} else {
				text += " " + string;
			}
		}
		
		if (!removeNewLine) {
			text += "\n";
		}
		if (enebleBackslashEscapes) {
			for (int i = 0; i <text.length()-1; i++) {
				if ((text.charAt(i)+"").equals("\\") ) {
					switch ((text.charAt(i+1)+"")) {
						case "t":
							text = text.substring(0, i) + '\t'  + text.substring(i+2);
							break;
						case "b":
							text = text.substring(0, i) + '\b'  + text.substring(i+2);
							break;
						case "n":
							text = text.substring(0, i) + '\n'  + text.substring(i+2);
							break;
						case "r":
							text = text.substring(0, i) + '\r'  + text.substring(i+2);
							break;
						case "f":
							text = text.substring(0, i) + '\f'  + text.substring(i+2);
							break;
						case "'":
							text = text.substring(0, i) + '\''  + text.substring(i+2);
							break;
						case "\"":
							text = text.substring(0, i) + '\"'  + text.substring(i+2);
							break;	
						case "\\":
							i++;
						default:
							break;
					}
				}
				
				
			}
		}

		getOutput().write(text);
	}
}
