package kernel.process.bin;

import kernel.process.Process;
import kernel.process.ProcessManager;
import kernel.service.CustomException;

/**
 * Class for kill process
 *
 */
public class Kill extends Process {

	@Override
	public void run() {
		String text = "";

		if (getParametsAndArguments().size() == 0) {
			System.err.println("No parameter.");
			text += "No parametr";
		}
		else if (getParametsAndArguments().size() > 1) {
			System.err.println("Enough parameters.");
			text += "Enough parameters";
		}
		else {
			try {
				int PIDtoKill = Integer.parseInt(getParametsAndArguments().get(0));
				ProcessManager pm = ProcessManager.getProcessManager();
				if (pm.killProcess(PIDtoKill) == false) {
					text += "Can not be killed\n";
				}
			}
			catch (NumberFormatException e) {
				CustomException.printException(e, "Paramert isn't a number.");
			}
		}

		getOutput().write(text);
	}

}
