package kernel.process.bin;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;

import kernel.file.FileManager;
import kernel.process.Process;
import kernel.service.CustomException;

/**
 * Write the manual for some specific command on the terminal.<br>
 * The manual is a text file with extension <strong>.man</strong>
 * containing manual for command specified in the name of file.<br>
 *
 */
public class Man extends Process {

	@Override
	public void run() {
		String text = "";
		
		if (getParametsAndArguments().size() == 0) {
			text += "Existujici manualove stranky:\n";
			FileManager fm = new FileManager();
			String path = getClass().getResource("man_files").toString().substring(5);
			List<File> files = fm.loadAllFileFromDir(path);
			String filename;
			for(File f : files){
				filename = f.getName();
				text += filename.substring(0, filename.length() - 4) + "\n";
		}	
		}else {
			InputStream file = getClass().getResourceAsStream("man_files/"+ getParametsAndArguments().get(0).toLowerCase() + ".man");
			BufferedReader reader = null;
			try{
				reader = new BufferedReader(new InputStreamReader(file));
				String         line 		= null;
			    StringBuilder  strBuilder 	= new StringBuilder();
			    
			    while( ( line = reader.readLine() ) != null ) {
			    	strBuilder.append( line + "\n" );
	
				}
			    text += strBuilder.toString();
			    try {
					reader.close();
				} catch (IOException e) {
					CustomException.printException(e, "Cannot close the file!");
				}
			} catch (NullPointerException e){
				text += "Manulov soubor k tomuto pkazu nen dostupn.\n";
				CustomException.printException(e, "Cannot open file for this command!");
			} catch (IOException e) {
				CustomException.printException(e, "Cannot read from file!");
			}
		    
		}	
		getOutput().write(text);
	}
}
