package kernel.process.bin;

import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;

import kernel.file.FileManager;
import kernel.process.Process;

/**
 * Class for sort of line from stream, file or terminal
 *
 */
public class Sort extends Process {

	@Override
	public void run() {
		List<String> lines = new LinkedList<String>();
		
		String line;
		if (getParametsAndArguments().size() > 0) { 
			String file = getParametsAndArguments().get(0);
			FileManager fm = new FileManager();
			fm.openFileForRead(file);
			while((line = fm.readFromFile()) != null){
				lines.add(line);
			}
			fm.closeReadToFile();
		} else {
			while ((line = getInput().readLine()) != null && line.charAt(line.length()-1) != Character.ENCLOSING_MARK) {
				lines.add(line);
			} 	
		}
		Object[] linesArray = lines.toArray();
		Arrays.sort(linesArray);
		
		for (int i = 0; i < linesArray.length; i++) {
			linesArray[i] += "\n";
			getOutput().write((String)linesArray[i]);
		}
	}
}