package kernel.process.sbin;

import kernel.process.IProcess;
import kernel.process.Process;
import kernel.process.ProcessManager;
import kernel.service.Input;
import kernel.service.Output;
import kernel.terminal.Terminal;

/**
 * Class for login to OS and start process of shell
 *
 */
public class Init extends Process {
	@Override
	public void run() {	
		Login login;
		
		do {
			login = new Login();
			login.setOutput(new Output(Terminal.getTerminal().getInput()));
			login.setInput(new Input(Terminal.getTerminal().getOutput()));
			
			ProcessManager.getProcessManager().createProcess(login, this);
			
			try {
				login.join();
				ProcessManager.getProcessManager().closeProcess(login.getPID());
			} catch (InterruptedException e1) {
				e1.printStackTrace();
			}
						
			if (login.getLogin() == true) {			
				ProcessManager.getProcessManager().createProcess(new Shell(), this);
				try {
					IProcess shell;
					while ((shell = ProcessManager.getProcessManager().getShell()) != null) {
						((Thread)shell).join();
						ProcessManager.getProcessManager().closeProcess(shell.getPID());
					}
				} catch (InterruptedException e) {
					e.printStackTrace();
				}	
			}
		} while (login.getLogin() == false);
		
	}
	
}
