package kernel.relation;

import java.util.HashMap;

/**
 * Class for manager of instance class Relation (Singleton)
 * 
 * @author 1Max11
 *
 */
public class RelationManager {
	/**
	 * Instance of RelationManager
	 */
	private static RelationManager relationManager;
	/**
	 * Map of relations
	 */
	private HashMap<Integer, Relation> relations = new HashMap<Integer, Relation>();
	/**
	 * Method for get instance of RelationManager
	 * 
	 * @return instance of RelationManager
	 */
	public static RelationManager getRelationManager() {
		if (relationManager == null) {
			relationManager = new RelationManager();
		}
		return relationManager;
	}
	/**
	 * Method for create relation
	 * 
	 * @param shellID - Shell id
	 */
	public void createRelation(int shellID) {
		relations.put(shellID, new Relation());
	}
	/**
	 * Method for get relation
	 * 
	 * @param shellID
	 * @return relation
	 */
	public Relation getRelation(int shellID) {
		return relations.get(shellID);
	}
}
