package kernel.service;

/**
 * Class for record exception
 * 
 * @author 1Max11
 *
 */
public class CustomException extends Exception{
	
	private static final long serialVersionUID = 1L;

	/**
	 * Print exception on console
	 * 
	 * @param e Exception
	 * @param msg Message
	 */
	public static void printException(Exception e, String msg){
		String x = e.getStackTrace()[2].getFileName()+":"+e.getStackTrace()[2].getLineNumber();
		System.err.println(msg + " | " + e.getClass() + " on (" + x + ") \n");
	}
	
	/**
	 * Print exception on console
	 */
	@Override
	public void printStackTrace() {
		String x = super.getStackTrace()[2].getFileName()+":"+super.getStackTrace()[2].getLineNumber();
		System.err.println(super.getClass() + " on (" + x + ") \n");
	}
}
