package kernel.service;

import java.io.IOException;
import java.io.InputStream;

/**
 * Class for read from stream
 *
 */
public class Input {
	
	private InputStream is;
	/**
	 * Constructor for create instance Input
	 * 
	 * @param is InputStream
	 */
	public Input(InputStream is) {
		this.is = is;
	}
	/**
	 * Method for read line from stream
	 * 
	 * @return
	 */
	public String readLine() {
		try {
			String line = "";
			while (true) {
				int i;					
				while((i = is.read()) >= 0) {
					if (i == '\n') {					
						return line;
					}
					line += (char)i;
					if (i == Character.ENCLOSING_MARK) {
						return line;
					}
				}	
			}
		} catch (IOException e) {
			//e.printStackTrace();
			//ignore - os is closing
		}
		return null;
	}
	
}
